/**************************************************************************

	TrayClock

	main.c

	(C) Copyright 1999 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <commctrl.h>
#include <tchar.h>

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define MAIN_WND_CLASS			TEXT("tcWndCls")
#define BUF_SIZE				256

#define WM_ENDAPP				(WM_USER + 100)
#define WM_TRAY_NOTIFY			(WM_USER + 101)
#define TRAY_ID					1
#define ID_CLOCK_TIMER			1
#define TIMER_INTERVAL			10000

#define ID_MENUITEM_DUMMY		40001
#define ID_MENUITEM_QUIT		40002

#define LINE_COLOR				RGB(0, 0, 0)
#define MASK_COLOR				RGB(255, 255, 255)

#define ICONSIZE				16
#define IMAGESIZE				14


/**************************************************************************
	Global Variables
**************************************************************************/

static HICON hBackIcon;


/******************************************************************************

	FillBitmap

	rbg}bv̎w͈̔͂w̐FœhԂ

******************************************************************************/

static void FillBitmap(HDC mdc, HBITMAP hBitmap, LONG x, LONG y, COLORREF Color)
{
	HBITMAP hRetBmp;
	HBRUSH hBrush;
	RECT fRect;

	hRetBmp = SelectObject(mdc, hBitmap);
	/* uV̍쐬 */
	hBrush = CreateSolidBrush(Color);
	fRect.top = fRect.left = x;
	fRect.right = fRect.bottom = y;
	/* hԂ */
	FillRect(mdc, &fRect, hBrush);
	DeleteObject(hBrush);
	SelectObject(mdc, hRetBmp);
}


/******************************************************************************

	ConvLinePoint

	j̈ʒuvZ

******************************************************************************/

static void ConvLinePoint(const int hmx, const int hmy, POINT *pt, int flag)
{
	switch(flag)
	{
	case 0:		/* 0`14 */
		pt->x = hmx;
		pt->y = hmy;
		break;
	case 1:		/* 15`29 */
		pt->x = IMAGESIZE - hmy;
		pt->y = hmx;
		break;
	case 2:		/* 30`44 */
		pt->x = IMAGESIZE - hmx;
		pt->y = IMAGESIZE - hmy;
		break;
	case 3:		/* 45`59 */
		pt->x = hmy;
		pt->y = IMAGESIZE - hmx;
		break;
	}
}


/******************************************************************************

	CreateTimeIcon

	vACR̍쐬

******************************************************************************/

static HICON CreateTimeIcon(HWND hWnd)
{
	HDC hdc, mdc;
	HIMAGELIST IconList, mIconList;
	HICON hIcon;
	HBITMAP hBitmap, hMaskBitmap;
	HBITMAP hRetBmp;

	POINT pt[2];
	SYSTEMTIME systim;

	int index, flag;
	static int gMinute = -1;
	/* j */
	const int hx[] = {7,  8,  9, 10, 11, 11, 12, 12};
	const int hy[] = {2,  2,  2,  3,  3,  4,  5,  6};
	/* j */
	const int mx[] = {7,  8,  9, 10, 10, 11, 12, 12, 12, 13, 13, 13, 14, 14, 14};
	const int my[] = {0,  0,  0,  0,  1,  1,  1,  2,  2,  2,  3,  4,  4,  5,  6};

	/* ̎擾 */
	GetLocalTime(&systim);
	if(systim.wMinute == gMinute){
		return NULL;
	}
	gMinute = systim.wMinute;

	/* GDIIuWFNg̍쐬 */
	hdc = GetDC(hWnd);
	mdc = CreateCompatibleDC(hdc);

	/* jrbg}bv */
	hBitmap = CreateCompatibleBitmap(hdc, ICONSIZE, ICONSIZE);
	FillBitmap(mdc, hBitmap, 0, ICONSIZE, LINE_COLOR);

	/* }XNrbg}bv */
	hMaskBitmap = CreateCompatibleBitmap(hdc, ICONSIZE, ICONSIZE);
	FillBitmap(mdc, hMaskBitmap, 0, ICONSIZE, MASK_COLOR);
	ReleaseDC(hWnd, hdc);
	hRetBmp = SelectObject(mdc, hMaskBitmap);

	pt[0].x = pt[0].y = IMAGESIZE / 2;
	/* j̕` */
	index = ((systim.wHour % 12) * 5) + (systim.wMinute / 15);
	flag = index / 15;
	index %= 15;
	index = (((index * 10) / 2) + 5) / 10;
	ConvLinePoint(hx[index], hy[index], &pt[1], flag);
	Polyline(mdc, pt, sizeof(pt) / sizeof(POINT));

	/* j̕` */
	index = systim.wMinute % 15;
	flag = systim.wMinute / 15;
	ConvLinePoint(mx[index], my[index], &pt[1], flag);
	Polyline(mdc, pt, sizeof(pt) / sizeof(POINT));

	/* S */
	FillBitmap(mdc, hMaskBitmap, IMAGESIZE / 2, IMAGESIZE / 2 + 1, MASK_COLOR);

	/* GDIIuWFNg̉ */
	SelectObject(mdc, hRetBmp);
	DeleteDC(mdc);

	/* C[WXg̍쐬 */
	IconList = ImageList_Create(ICONSIZE, ICONSIZE, ILC_COLOR | ILC_MASK, 2, 2);
	ImageList_AddIcon(IconList, hBackIcon);
	ImageList_Add(IconList, hBitmap, hMaskBitmap);
	DeleteObject(hBitmap);
	DeleteObject(hMaskBitmap);

	/* jrbg}bvƔwiACR}[WăACR쐬 */
	mIconList = ImageList_Merge(IconList, 0, IconList, 1, 0, 0);
	hIcon = ImageList_GetIcon(mIconList, 0, ILD_NORMAL);
	ImageList_Destroy(mIconList);
	ImageList_Destroy(IconList);
	return hIcon;
}


/******************************************************************************

	GetDateTimeString

	̎擾

******************************************************************************/

static void GetDateTimeString(TCHAR *ret)
{
	int i;

	i = GetDateFormat(0, DATE_LONGDATE, NULL, NULL, ret, BUF_SIZE - 1);
	if(i > 0){
		*(ret + i - 1) = TEXT(' ');
	}
	*(ret + i) = TEXT('\0');
	GetTimeFormat(0, TIME_NOSECONDS, NULL, NULL, ret + i, BUF_SIZE - i - 1);
}


/******************************************************************************

	TrayMessage

	^XNgC̃ACR̐ݒ

******************************************************************************/

static BOOL TrayMessage(HWND hWnd, DWORD dwMessage, UINT uID, HICON hIcon, TCHAR *pszTip)
{
	NOTIFYICONDATA tnd;
	TCHAR *r;

	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = hWnd;
	tnd.uID	= uID;
	tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage = WM_TRAY_NOTIFY;
	tnd.hIcon = hIcon;
	r = tnd.szTip;
	while(*(r++) = *(pszTip++));
	return Shell_NotifyIcon(dwMessage, &tnd);
}


/******************************************************************************

	SetTrayIcon

	^XNgCɃACRݒ肷

******************************************************************************/

static void SetTrayIcon(HWND hWnd, HICON hIcon)
{
	TCHAR buf[BUF_SIZE];

	GetDateTimeString(buf);
	if(TrayMessage(hWnd, NIM_MODIFY, TRAY_ID, hIcon, buf) == FALSE){
		/* ύXłȂꍇ͒ǉs */
		TrayMessage(hWnd, NIM_ADD, TRAY_ID, hIcon, buf);
	}
}


/******************************************************************************

	ShowPopupMenu

	j[\

******************************************************************************/

static void ShowPopupMenu(HWND hWnd)
{
	HMENU hMenu;
	TCHAR buf[BUF_SIZE];
#ifdef _WIN32_WCE
	RECT WndRect;
#else
	POINT apos;
#endif

	hMenu = CreatePopupMenu();
	if(hMenu == NULL){
		return;
	}
	/* j[ɒǉ */
	GetDateTimeString(buf);
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_DUMMY, buf);
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_QUIT, TEXT("&Exit"));

	SetForegroundWindow(hWnd);
#ifdef _WIN32_WCE
	GetWindowRect(hWnd, &WndRect);
	/* j[\ */
	TrackPopupMenu(hMenu,TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
		WndRect.right, WndRect.bottom, 0, hWnd, NULL);
#else
	GetCursorPos(&apos);
	/* j[\ */
	TrackPopupMenu(hMenu,TPM_TOPALIGN | TPM_RIGHTBUTTON | TPM_LEFTBUTTON,
		apos.x, apos.y, 0, hWnd, NULL);
#endif
	DestroyMenu(hMenu);
	PostMessage(hWnd, WM_NULL, 0, 0);
}


/******************************************************************************

	MainProc

	MainvV[W

******************************************************************************/

static LRESULT CALLBACK MainProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HICON hIcon;

	switch(msg)
	{
	case WM_CREATE:
		/* wiACR */
		hBackIcon = (HICON)LoadImage(((LPCREATESTRUCT)lParam)->hInstance,
			MAKEINTRESOURCE(IDI_ICON_BACK), IMAGE_ICON, ICONSIZE, ICONSIZE, 0);

		SendMessage(hWnd, WM_TIMER, ID_CLOCK_TIMER, 0);
		/* 10bԊuŃ^C}[𓮂 */
		SetTimer(hWnd, ID_CLOCK_TIMER, TIMER_INTERVAL, NULL);
		break;

#ifdef _WIN32_WCE
	case WM_HIBERNATE:
#else
	case WM_ENDSESSION:
#endif
	case WM_ENDAPP:
		/* ^XNgC̃ACR폜 */
		TrayMessage(hWnd, NIM_DELETE, TRAY_ID, NULL, TEXT(""));
		if(hIcon != NULL) DestroyIcon(hIcon);
		DestroyIcon(hBackIcon);
		DestroyWindow(hWnd);
		break;

	case WM_CLOSE:
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_TIMER:
		switch(wParam)
		{
		case ID_CLOCK_TIMER:
			{
				HICON hTmpIcon;

				/* ^XNCɕ\ACR̍쐬 */
				hTmpIcon = CreateTimeIcon(hWnd);
				if(hTmpIcon == NULL){
					break;
				}
				if(hIcon != NULL) DestroyIcon(hIcon);
				hIcon = hTmpIcon;
				/* ^XNgCɃACRݒ肷 */
				SetTrayIcon(hWnd, hIcon);
			}
			break;
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case ID_MENUITEM_QUIT:
			SendMessage(hWnd, WM_ENDAPP, 0, 0);
			break;
		}
		break;

	case WM_TRAY_NOTIFY:
		switch (lParam)
		{
#ifndef _WIN32_WCE
		case WM_RBUTTONUP:
#endif
		case WM_LBUTTONUP:
			ShowPopupMenu(hWnd);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitApplication

	EBhE̍쐬

******************************************************************************/

static HWND InitApplication(HANDLE hInstance)
{
	WNDCLASS  wc;

	/* EBhENXo^ */
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)MainProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = NULL;
	wc.hCursor = NULL;
	wc.hbrBackground = NULL;
	wc.lpszMenuName =  NULL;
	wc.lpszClassName = MAIN_WND_CLASS;
	RegisterClass(&wc);

	/* EBhE쐬 */
	return CreateWindow(MAIN_WND_CLASS, TEXT(""), WS_OVERLAPPED,
		0, 0, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int CmdShow)
{
	MSG msg;

	/* ɋNĂꍇ͏I */
	if(FindWindow(MAIN_WND_CLASS, NULL) != NULL){
		return 0;
	}

	/* EBhE̍쐬 */
	if(InitApplication(hInstance) == NULL){
		return 0;
	}

	/* bZ[W[v */
	while(GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}
/* End of source */
